/* -------------------------------------------------------------------------
 | Copyright (C) 2006  Ali Rawashdeh
 | This program is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 | 
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 | 
 | You should have received a copy of the GNU General Public License along
 | with this program (see License.txt); if not, write to the Free Software
 | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using HomeDev.Useful;
using HomeDev.RSSTicker.Controller;
using HomeDev.RSSTicker.UI;

namespace HomeDev.RSSTicker.UI
{
	public delegate void AddLabelToPanelDelegate(LinkLabel label_p);
	public delegate LinkLabel GetNextHeadlineDelegate();
	public delegate void MoveToNextHeadlinePositionDelegate();

	/// <summary>
	/// The User Interface for the Ticker
	/// </summary>
	public class MainBar : System.Windows.Forms.Form
	{
		// Declarations
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel rightPanel;
		private System.Windows.Forms.Panel rssPanel;
		private System.Windows.Forms.Panel settingsPanel;
		private System.Windows.Forms.Panel closePanel;
		private System.ComponentModel.Container components = null;

		private Point mouseOffset;
		private bool isMouseDown = false;
		private HomeDev.RSSTicker.Controller.Controller controller_i;
		private System.Windows.Forms.Panel textPanel;
		private Thread tickThread_i;
		private AddLabelToPanelDelegate addLabelToPanelDelegate_i;
		private GetNextHeadlineDelegate getNextHeadlineDelegate_i;
		private MoveToNextHeadlinePositionDelegate moveToNextHeadlinePositionDelegate_i;
		private RestartTickThreadDelegate restartTickThreadDelegate_i;
		private BookmarksForm bookmarksForm_i;
		private SettingsForm settingsForm_i;

		static public bool firsttime_i;


		#region ctor

		public MainBar()
		{
			// 08/16 Y.T ADD For .Net FrameWorkΉ
			//WXgGET
			//HKEY_CURRENT_USER_Software_test_subkey
			//HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft .NET Framework 2.0
			Microsoft.Win32.RegistryKey regkey1033 =
				Microsoft.Win32.Registry.LocalMachine.OpenSubKey(
				@"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Microsoft .NET Framework 1.1  (1033)", false);
			Microsoft.Win32.RegistryKey regkey1041 =
				Microsoft.Win32.Registry.LocalMachine.OpenSubKey(
				@"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Microsoft .NET Framework 1.1  (1041)", false);

			try
			{
				//L[݂ȂƂ null Ԃ
				if (regkey1033 == null)
				{
					if(regkey1041 == null)
					{
						MessageBox.Show("̃\tg𐳏ɓ삳ɂ́AMicrosoft .NET FRAMWORK 1.1KvłBLMicrosoft .NET FRAMWORK 1.1CXg[ĉB\n\nʃo[W Microsoft .NET FRAMWORK 2.0 CXg[ĂȂ PC ł́AN͂łĂAɓ삷ۏ͂܂B", "Information");
						System.Diagnostics.Process.Start("http://www.microsoft.com/downloads/info.aspx?na=90&p=&SrcDisplayLang=ja&SrcCategoryId=&SrcFamilyId=262d25e3-f589-4842-8157-034d1e7cf3a3&u=http%3a%2f%2fdownload.microsoft.com%2fdownload%2f5%2fb%2f5%2f5b510096-5b68-4e3f-8f9e-56fb7a80ca81%2fdotnetfx.exe");
						this.Close();
					}
				}
				else
				{
				}
			}
			catch
			{
			}

			try
			{
				Screen screen = Screen.PrimaryScreen;

				InitializeComponent();
				// Set up the logger TODO: change this value to false after if logging should be turned off
				Logger.Open("ticker.log",true);

				// Set the size of the ticker and the locations of the panels
				this.TopMost = true;
				this.Size = new System.Drawing.Size(screen.WorkingArea.Width,29);
				this.Location = new System.Drawing.Point(0,screen.WorkingArea.Height - this.ClientSize.Height);
				this.rightPanel.Location = new System.Drawing.Point(this.Width - rightPanel.Width, 0);
				this.settingsPanel.Location = new System.Drawing.Point(this.Width -  37, 7);
				this.closePanel.Location = new System.Drawing.Point(this.Width - 20, 7);
				this.textPanel.Width = (screen.WorkingArea.Width - 31 - 47);
				this.textPanel.Height = 19;
				this.textPanel.Location = new System.Drawing.Point(31,5);

				// Set up the Event Handlers
				this.rssPanel.MouseMove += new MouseEventHandler(this.rssPanel_MouseMove);
				this.settingsPanel.MouseMove += new MouseEventHandler(this.settingsPanel_MouseMove);
				this.closePanel.MouseMove += new MouseEventHandler(this.closePanel_MouseMove);
				this.rssPanel.MouseDown += new MouseEventHandler(this.rssPanel_MouseDown);
				this.settingsPanel.MouseDown += new MouseEventHandler(this.settingsPanel_MouseDown);
				this.closePanel.MouseDown += new MouseEventHandler(this.closePanel_MouseDown);
				this.MouseDown += new MouseEventHandler(this.MainBar_MouseDown);
				this.MouseMove += new MouseEventHandler(this.MainBar_MouseMove);
				this.MouseUp += new MouseEventHandler(this.MainBar_MouseUp);

				// Set up the delegates
				addLabelToPanelDelegate_i = new AddLabelToPanelDelegate(this.AddLabelToPanel);
				getNextHeadlineDelegate_i = new GetNextHeadlineDelegate(this.GetNextHeadline);
				moveToNextHeadlinePositionDelegate_i = new MoveToNextHeadlinePositionDelegate(this.MoveToNextHeadlinePosition);
				restartTickThreadDelegate_i = new RestartTickThreadDelegate(this.RestartTickThread);

				// Initialise the controller
				controller_i = new HomeDev.RSSTicker.Controller.Controller(this.textPanel, restartTickThreadDelegate_i);
			
				// 07/13 Y.T ADD For initial setting 
				firsttime_i = true;
				// 07/13 Y.T END For initial setting 

				tickThread_i = new Thread(new ThreadStart(this.MoveLeft));
				tickThread_i.Start();
			}
			catch
			{}
		}
		
		#endregion ctor

		#region Other Methods

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );

			// Clsoe the logger
			Logger.Close();
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainBar());
		}

		#endregion Other Methods

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainBar));
			this.panel1 = new System.Windows.Forms.Panel();
			this.rssPanel = new System.Windows.Forms.Panel();
			this.rightPanel = new System.Windows.Forms.Panel();
			this.settingsPanel = new System.Windows.Forms.Panel();
			this.closePanel = new System.Windows.Forms.Panel();
			this.textPanel = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("panel1.BackgroundImage")));
			this.panel1.Controls.Add(this.rssPanel);
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(31, 29);
			this.panel1.TabIndex = 0;
			// 
			// rssPanel
			// 
			this.rssPanel.BackColor = System.Drawing.Color.White;
			this.rssPanel.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("rssPanel.BackgroundImage")));
			this.rssPanel.Location = new System.Drawing.Point(6, 7);
			this.rssPanel.Name = "rssPanel";
			this.rssPanel.Size = new System.Drawing.Size(14, 14);
			this.rssPanel.TabIndex = 2;
			// 
			// rightPanel
			// 
			this.rightPanel.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("rightPanel.BackgroundImage")));
			this.rightPanel.Location = new System.Drawing.Point(888, 0);
			this.rightPanel.Name = "rightPanel";
			this.rightPanel.Size = new System.Drawing.Size(47, 29);
			this.rightPanel.TabIndex = 1;
			// 
			// settingsPanel
			// 
			this.settingsPanel.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("settingsPanel.BackgroundImage")));
			this.settingsPanel.Location = new System.Drawing.Point(896, 8);
			this.settingsPanel.Name = "settingsPanel";
			this.settingsPanel.Size = new System.Drawing.Size(13, 13);
			this.settingsPanel.TabIndex = 2;
			// 
			// closePanel
			// 
			this.closePanel.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("closePanel.BackgroundImage")));
			this.closePanel.Location = new System.Drawing.Point(912, 8);
			this.closePanel.Name = "closePanel";
			this.closePanel.Size = new System.Drawing.Size(13, 13);
			this.closePanel.TabIndex = 3;
			// 
			// textPanel
			// 
			this.textPanel.BackColor = System.Drawing.Color.Transparent;
			this.textPanel.Location = new System.Drawing.Point(32, 8);
			this.textPanel.Name = "textPanel";
			this.textPanel.Size = new System.Drawing.Size(856, 16);
			this.textPanel.TabIndex = 4;
			// 
			// MainBar
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(936, 29);
			this.Controls.Add(this.textPanel);
			this.Controls.Add(this.closePanel);
			this.Controls.Add(this.settingsPanel);
			this.Controls.Add(this.rightPanel);
			this.Controls.Add(this.panel1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.MaximumSize = new System.Drawing.Size(3000, 29);
			this.MinimumSize = new System.Drawing.Size(0, 29);
			this.Name = "MainBar";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "Form1";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainBar_Closing);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Event Handler Methods

		/// <summary>
		/// This method is called when the pointer goes over the Bookmarks button
		/// </summary>
		/// <param name="source"></param>
		/// <param name="args"></param>
		public void rssPanel_MouseMove(object source, MouseEventArgs args)
		{
			Cursor.Current = Cursors.Hand;
		}

		/// <summary>
		/// This method is called when the pointer goes over the Settings button
		/// </summary>
		/// <param name="source"></param>
		/// <param name="args"></param>
		public void settingsPanel_MouseMove(object source, MouseEventArgs args)
		{
			Cursor.Current = Cursors.Hand;
		}

		/// <summary>
		/// This methos is called whtn the pointer goes over the Close button
		/// </summary>
		/// <param name="source"></param>
		/// <param name="args"></param>
		public void closePanel_MouseMove(object source, MouseEventArgs args)
		{
			Cursor.Current = Cursors.Hand;
		}

		/// <summary>
		/// This method is called when the user clicks on the Bookmarks button
		/// </summary>
		/// <param name="source"></param>
		/// <param name="args"></param>
		public void rssPanel_MouseDown(object source, MouseEventArgs args)
		{
			if((bookmarksForm_i == null) || (bookmarksForm_i.IsDisposed))
			{
				bookmarksForm_i = new BookmarksForm(this.controller_i);
			}
			bookmarksForm_i.Show();
			bookmarksForm_i.BringToFront();
		}

		/// <summary>
		/// This method is called when the user clicks on the Settings button
		/// </summary>
		/// <param name="source"></param>
		/// <param name="args"></param>
		public void settingsPanel_MouseDown(object source, MouseEventArgs args)
		{
			if((settingsForm_i == null) || (settingsForm_i.IsDisposed))
			{
				settingsForm_i = new SettingsForm(this.controller_i);
			}
			settingsForm_i.Show();
			settingsForm_i.BringToFront();
		}


		/// <summary>
		/// This method is called when the user clicks on the Close button
		/// </summary>
		/// <param name="source"></param>
		/// <param name="args"></param>
		public void closePanel_MouseDown(object source, MouseEventArgs args)
		{
			this.Close();
		}

		/// <summary>
		/// Called when the user clicks on the Main Bar... used for click-dragging the bar about
		/// </summary>
		private void MainBar_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left) 
			{
				mouseOffset = new Point(-e.X,-e.Y);
				isMouseDown = true;
			}    
		}

		/// <summary>
		/// Called when the user moves the mouse pointer
		/// </summary>
		private void MainBar_MouseMove(object sender, 
			System.Windows.Forms.MouseEventArgs e)
		{
			if (isMouseDown) 
			{
				Point mousePos = Control.MousePosition;
				mousePos.Offset(mouseOffset.X, mouseOffset.Y);
				// Only allow the bar to be move up and down for now
				Location = new System.Drawing.Point(Location.X,mousePos.Y);
			}
		}

		/// <summary>
		/// Called when the mouse button is released
		/// </summary>
		private void MainBar_MouseUp(object sender, 
			System.Windows.Forms.MouseEventArgs e)
		{
			// Changes the isMouseDown field so that the form does
			// not move unless the user is pressing the left mouse button.
			if (e.Button == MouseButtons.Left) 
			{
				isMouseDown = false;
			}
		}

		/// <summary>
		/// This method is called when the form is closed
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void MainBar_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.tickThread_i.Abort();
		}

		/// <summary>
		/// This method is called when the pointer moves over a headline
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void  currentLabel_MouseMove(object sender, MouseEventArgs e)
		{
			if(this.tickThread_i.ThreadState == ThreadState.Running)
			{
				this.tickThread_i.Suspend();
			}
		}

		/// <summary>
		/// This method is called when the pointer moves away from the headline
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void currentLabel_MouseLeave(object sender, EventArgs e)
		{
			if(this.tickThread_i.ThreadState == ThreadState.Suspended)
			{
				this.tickThread_i.Resume();
			}
		}

		#endregion Event Handler Methods

		#region Thread Methods

		/// <summary>
		/// This method runs in a separate thread and is responsible for scrolling all the linklabels to the left
		/// </summary>
		public void MoveLeft()
		{
			try
			{
				// pause if this is the first time it is run
				Thread.Sleep(30);

				//Initialise the variables
				bool firstAdded = false;
				LinkLabel labelToRemove = null;
				LinkLabel currentLabel = new LinkLabel();

				// Loop the next section indefinately
				while(true)
				{				
					// Check whether or not this is the first label to be added
					if((firstAdded == false))
					{
						// Fetch the first label, add the event handlers, then add it to the panel
						currentLabel = (LinkLabel)this.Invoke(this.getNextHeadlineDelegate_i); 
						currentLabel.MouseMove += new MouseEventHandler(currentLabel_MouseMove);
						currentLabel.MouseLeave += new EventHandler(currentLabel_MouseLeave);
						this.BeginInvoke(this.moveToNextHeadlinePositionDelegate_i);
						this.Invoke(addLabelToPanelDelegate_i, new Object[] {currentLabel});
						firstAdded = true;
					}
				
					// Check whether or not it is time to add a new label
					if((currentLabel.Right == this.textPanel.Width - 12) 
						|| (currentLabel.Right == this.textPanel.Width - 11))
					{
						// Fetch a new label, add the event handlers then add it to the panel
						currentLabel = (LinkLabel)this.Invoke(this.getNextHeadlineDelegate_i);
						currentLabel.MouseMove += new MouseEventHandler(currentLabel_MouseMove);
						currentLabel.MouseLeave += new EventHandler(currentLabel_MouseLeave);
						this.BeginInvoke(this.moveToNextHeadlinePositionDelegate_i);
						this.Invoke(addLabelToPanelDelegate_i, new Object[] {currentLabel});

					}
				
					// Go through each label in the panel and move it to the left

					foreach(LinkLabel label in this.textPanel.Controls)
					{
						label.Left = label.Left - 2;
						if(label.Right <= 0)
						{
							labelToRemove = label;
						}
					}

					// Remove any labels that can no longer be seen
					if(labelToRemove != null)
					{
						this.textPanel.Controls.Remove(labelToRemove);
						labelToRemove = null;
						GC.Collect();
					}
					// Pause the thread to give the effect of a particular user-defined scroll speed
					Thread.Sleep(this.controller_i.CurrentScrollSpeed);
				}
			}
			catch(Exception e)
			{
				Logger.Log(e.Message);
			}
		}

		#endregion Thread Methods

		#region Public Methods

		/// <summary>
		/// This method is used to add a LinkLabel to the panel
		/// </summary>
		/// <param name="label"></param>
		public void AddLabelToPanel(LinkLabel label)
		{
			this.textPanel.Controls.Add(label);
		}

		/// <summary>
		/// This method fetches the next headline to be added from the controller
		/// </summary>
		/// <returns></returns>
		public LinkLabel GetNextHeadline()
		{
			return this.controller_i.GetNextLabel();
		}	

		/// <summary>
		/// This method increments the headline position
		/// </summary>
		public void MoveToNextHeadlinePosition()
		{
			this.controller_i.MoveToNextHeadlinePosition();
		}

		/// <summary>
		/// This method restarts the MoveLeft thread
		/// </summary>
		public void RestartTickThread()
		{	
			this.tickThread_i.Abort();
			tickThread_i = new Thread(new ThreadStart(this.MoveLeft));
			tickThread_i.Start();		
		}

		#endregion Public Methods
	}
}
