/* -------------------------------------------------------------------------
 | Copyright (C) 2006  Ali Rawashdeh
 | This program is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 | 
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 | 
 | You should have received a copy of the GNU General Public License along
 | with this program (see License.txt); if not, write to the Free Software
 | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using HomeDev.RSSTicker.Objects;
using HomeDev.RSSTicker.Controller;

namespace HomeDev.RSSTicker.UI
{
	/// <summary>
	/// Summary description for SettingsForm.
	/// </summary>
	public class SettingsForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabPage tabGeneral_i;
		private System.Windows.Forms.Button btnSave_i;
		private System.Windows.Forms.Button btnCancel_i;
		private System.Windows.Forms.TrackBar tbUpdateFreq_i;
		private System.Windows.Forms.TrackBar tbScrollSpeed_i;
		private System.Windows.Forms.Label lblUpdateFreqLabel_i;
		private System.Windows.Forms.Label lblScrollSpeedLabel_i;
		private System.Windows.Forms.Label lblScrollSpeed_i;
		private System.Windows.Forms.Label lblUpdateFrequency_i;
		private System.Windows.Forms.TabControl tabControl_i;
		private System.Windows.Forms.CheckBox cbNewBrowser_i;
		private System.ComponentModel.Container components = null;

		private int scrollSpeed_i;
		private int updateFrequency_i;
		private bool newBrowser_i;
		private HomeDev.RSSTicker.Controller.Controller controller_i;
		private System.Windows.Forms.Label label1;

		#region ctor

		public SettingsForm(HomeDev.RSSTicker.Controller.Controller controller_p)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			controller_i = controller_p;
			scrollSpeed_i = controller_p.Settings.Speed;
			// 7/7 Y.T ADD
			Console.WriteLine("value2:" + controller_p.Settings.UpdatePeriod);
			// 7/7 Y.T END
			updateFrequency_i = controller_p.Settings.UpdatePeriod;
			newBrowser_i = controller_p.Settings.NewBrowser;

			this.tbScrollSpeed_i.Value = scrollSpeed_i;
			this.tbUpdateFreq_i.Value = updateFrequency_i;
			this.lblScrollSpeed_i.Text = Convert.ToString(scrollSpeed_i);
			this.lblUpdateFrequency_i.Text = Convert.ToString(updateFrequency_i) + " seconds";
			this.cbNewBrowser_i.Checked = newBrowser_i;

			this.btnSave_i.Enabled = false;
		}

		#endregion ctor

		#region Other Methods

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion Other Methods

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SettingsForm));
			this.tabControl_i = new System.Windows.Forms.TabControl();
			this.tabGeneral_i = new System.Windows.Forms.TabPage();
			this.label1 = new System.Windows.Forms.Label();
			this.cbNewBrowser_i = new System.Windows.Forms.CheckBox();
			this.lblScrollSpeed_i = new System.Windows.Forms.Label();
			this.lblUpdateFrequency_i = new System.Windows.Forms.Label();
			this.lblScrollSpeedLabel_i = new System.Windows.Forms.Label();
			this.lblUpdateFreqLabel_i = new System.Windows.Forms.Label();
			this.tbScrollSpeed_i = new System.Windows.Forms.TrackBar();
			this.tbUpdateFreq_i = new System.Windows.Forms.TrackBar();
			this.btnSave_i = new System.Windows.Forms.Button();
			this.btnCancel_i = new System.Windows.Forms.Button();
			this.tabControl_i.SuspendLayout();
			this.tabGeneral_i.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbScrollSpeed_i)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.tbUpdateFreq_i)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl_i
			// 
			this.tabControl_i.Controls.Add(this.tabGeneral_i);
			this.tabControl_i.Location = new System.Drawing.Point(8, 7);
			this.tabControl_i.Name = "tabControl_i";
			this.tabControl_i.SelectedIndex = 0;
			this.tabControl_i.Size = new System.Drawing.Size(272, 265);
			this.tabControl_i.TabIndex = 0;
			// 
			// tabGeneral_i
			// 
			this.tabGeneral_i.Controls.Add(this.label1);
			this.tabGeneral_i.Controls.Add(this.cbNewBrowser_i);
			this.tabGeneral_i.Controls.Add(this.lblScrollSpeed_i);
			this.tabGeneral_i.Controls.Add(this.lblUpdateFrequency_i);
			this.tabGeneral_i.Controls.Add(this.lblScrollSpeedLabel_i);
			this.tabGeneral_i.Controls.Add(this.lblUpdateFreqLabel_i);
			this.tabGeneral_i.Controls.Add(this.tbScrollSpeed_i);
			this.tabGeneral_i.Controls.Add(this.tbUpdateFreq_i);
			this.tabGeneral_i.Location = new System.Drawing.Point(4, 21);
			this.tabGeneral_i.Name = "tabGeneral_i";
			this.tabGeneral_i.Size = new System.Drawing.Size(264, 240);
			this.tabGeneral_i.TabIndex = 0;
			this.tabGeneral_i.Text = "S";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 192);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(232, 37);
			this.label1.TabIndex = 12;
			this.label1.Text = "Note: This option only applies to Internet Explorer (Firefox users can set this o" +
				"ption in Firefox settings)";
			// 
			// cbNewBrowser_i
			// 
			this.cbNewBrowser_i.Checked = true;
			this.cbNewBrowser_i.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbNewBrowser_i.Location = new System.Drawing.Point(16, 155);
			this.cbNewBrowser_i.Name = "cbNewBrowser_i";
			this.cbNewBrowser_i.Size = new System.Drawing.Size(168, 29);
			this.cbNewBrowser_i.TabIndex = 11;
			this.cbNewBrowser_i.Text = "^CgNbNƐVuEUJ";
			this.cbNewBrowser_i.CheckedChanged += new System.EventHandler(this.cbNewBrowser_i_CheckedChanged);
			// 
			// lblScrollSpeed_i
			// 
			this.lblScrollSpeed_i.Location = new System.Drawing.Point(128, 80);
			this.lblScrollSpeed_i.Name = "lblScrollSpeed_i";
			this.lblScrollSpeed_i.Size = new System.Drawing.Size(72, 15);
			this.lblScrollSpeed_i.TabIndex = 6;
			// 
			// lblUpdateFrequency_i
			// 
			this.lblUpdateFrequency_i.Location = new System.Drawing.Point(120, 8);
			this.lblUpdateFrequency_i.Name = "lblUpdateFrequency_i";
			this.lblUpdateFrequency_i.Size = new System.Drawing.Size(88, 15);
			this.lblUpdateFrequency_i.TabIndex = 7;
			// 
			// lblScrollSpeedLabel_i
			// 
			this.lblScrollSpeedLabel_i.Location = new System.Drawing.Point(16, 81);
			this.lblScrollSpeedLabel_i.Name = "lblScrollSpeedLabel_i";
			this.lblScrollSpeedLabel_i.Size = new System.Drawing.Size(104, 15);
			this.lblScrollSpeedLabel_i.TabIndex = 3;
			this.lblScrollSpeedLabel_i.Text = "XN[Xs[h@F";
			// 
			// lblUpdateFreqLabel_i
			// 
			this.lblUpdateFreqLabel_i.Location = new System.Drawing.Point(16, 7);
			this.lblUpdateFreqLabel_i.Name = "lblUpdateFreqLabel_i";
			this.lblUpdateFreqLabel_i.Size = new System.Drawing.Size(104, 15);
			this.lblUpdateFreqLabel_i.TabIndex = 2;
			this.lblUpdateFreqLabel_i.Text = "Abvf[gx F";
			// 
			// tbScrollSpeed_i
			// 
			this.tbScrollSpeed_i.Location = new System.Drawing.Point(8, 103);
			this.tbScrollSpeed_i.Maximum = 100;
			this.tbScrollSpeed_i.Name = "tbScrollSpeed_i";
			this.tbScrollSpeed_i.Size = new System.Drawing.Size(248, 45);
			this.tbScrollSpeed_i.SmallChange = 5;
			this.tbScrollSpeed_i.TabIndex = 5;
			this.tbScrollSpeed_i.TickFrequency = 5;
			this.tbScrollSpeed_i.ValueChanged += new System.EventHandler(this.tbScrollSpeed_ValueChanged);
			// 
			// tbUpdateFreq_i
			// 
			this.tbUpdateFreq_i.Location = new System.Drawing.Point(8, 30);
			this.tbUpdateFreq_i.Maximum = 600;
			this.tbUpdateFreq_i.Name = "tbUpdateFreq_i";
			this.tbUpdateFreq_i.Size = new System.Drawing.Size(248, 45);
			this.tbUpdateFreq_i.SmallChange = 15;
			this.tbUpdateFreq_i.TabIndex = 10;
			this.tbUpdateFreq_i.TickFrequency = 30;
			this.tbUpdateFreq_i.Value = 30;
			this.tbUpdateFreq_i.ValueChanged += new System.EventHandler(this.tbUpdateFreq_ValueChanged);
			// 
			// btnSave_i
			// 
			this.btnSave_i.Enabled = false;
			this.btnSave_i.Location = new System.Drawing.Point(136, 280);
			this.btnSave_i.Name = "btnSave_i";
			this.btnSave_i.Size = new System.Drawing.Size(64, 22);
			this.btnSave_i.TabIndex = 1;
			this.btnSave_i.Text = "ۑ";
			this.btnSave_i.Click += new System.EventHandler(this.btnSave_i_Click);
			// 
			// btnCancel_i
			// 
			this.btnCancel_i.Location = new System.Drawing.Point(216, 280);
			this.btnCancel_i.Name = "btnCancel_i";
			this.btnCancel_i.Size = new System.Drawing.Size(64, 22);
			this.btnCancel_i.TabIndex = 2;
			this.btnCancel_i.Text = "LZ";
			this.btnCancel_i.Click += new System.EventHandler(this.btnCancel_i_Click);
			// 
			// SettingsForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(292, 318);
			this.Controls.Add(this.btnCancel_i);
			this.Controls.Add(this.btnSave_i);
			this.Controls.Add(this.tabControl_i);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MaximumSize = new System.Drawing.Size(300, 600);
			this.MinimumSize = new System.Drawing.Size(300, 272);
			this.Name = "SettingsForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ݒ";
			this.tabControl_i.ResumeLayout(false);
			this.tabGeneral_i.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbScrollSpeed_i)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.tbUpdateFreq_i)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Event Handler Methods

		/// <summary>
		/// This method is called when the update frequency is changed
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void tbUpdateFreq_ValueChanged(object sender, System.EventArgs e)
		{
			// 7/7 Y.T ADD
			Console.WriteLine("value5:" + this.tbUpdateFreq_i.Value);
			// 7/7 Y.T END
			this.updateFrequency_i = this.tbUpdateFreq_i.Value;
			this.lblUpdateFrequency_i.Text = Convert.ToString(this.tbUpdateFreq_i.Value) + " seconds";
			this.btnSave_i.Enabled = true;
		}

		/// <summary>
		/// THis method is called when the scroll speed is changed
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void tbScrollSpeed_ValueChanged(object sender, System.EventArgs e)
		{
			scrollSpeed_i = this.tbScrollSpeed_i.Value;
			this.lblScrollSpeed_i.Text = Convert.ToString(this.tbScrollSpeed_i.Value);
			this.btnSave_i.Enabled = true;
		}

		/// <summary>
		/// This method is called when the New Browser checkbox value changes
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void cbNewBrowser_i_CheckedChanged(object sender, System.EventArgs e)
		{
			this.newBrowser_i = this.cbNewBrowser_i.Checked;
			this.btnSave_i.Enabled = true;
		}

		/// <summary>
		/// This method is called when the Cancel button is clicked
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnCancel_i_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		/// <summary>
		/// This method is called when the Save button is clicked
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnSave_i_Click(object sender, System.EventArgs e)
		{
			this.controller_i.Settings.NewBrowser = this.newBrowser_i;
			LabelLinkClick.newBrowser = this.newBrowser_i;
			this.controller_i.Settings.Speed = this.scrollSpeed_i;
			// 7/7 Y.T ADD
			Console.WriteLine("value4:" + this.updateFrequency_i);
			// 7/7 Y.T END
			this.controller_i.Settings.UpdatePeriod = this.updateFrequency_i;
			this.controller_i.CurrentScrollSpeed = this.controller_i.GetScrollSpeedFromSetting(this.scrollSpeed_i);
			this.controller_i.Settings.Save("settings.xml");
			this.controller_i.UpdateFeedsTimer();
			this.Close();
		}

		#endregion Event Handler Methods




	}
}
