/* -------------------------------------------------------------------------
 | Copyright (C) 2006  Ali Rawashdeh
 | This program is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 | 
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 | 
 | You should have received a copy of the GNU General Public License along
 | with this program (see License.txt); if not, write to the Free Software
 | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------*/
using System;
using HomeDev.Useful;
using HomeDev.RSSTicker.Objects;
using NUnit.Framework;
using System.Xml;
using System.Xml.Serialization;
using System.IO;


namespace UnitTests
{
	/// <summary>
	/// Unit test for the bookmark class
	/// </summary>
	[TestFixture]
	public class Bookmark_UT
	{

		// Declarations
		Bookmark bookmark1;
		Bookmark bookmark2;

		public Bookmark_UT()
		{
		}
		
		// Setup method
		[SetUp]
		public void Setup()
		{
			Logger.Open("log.txt", true);
		}

		// Teardown method
		[TearDown]
		public void Teardown()
		{
			Logger.Close();
		}

		/// <summary>
		/// This tests the constructors and the bookmark object
		/// </summary>
		[Test]
		public void BookmarkTest()
		{
			bookmark1 = new Bookmark("Bookmark1", @"http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/front_page/rss.xml");
			bookmark2 = new Bookmark("Bookmark2", @"http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/technology/rss.xml", 10);

			Logger.Log(bookmark1.ToString());
			Logger.Log(bookmark2.ToString());
		}

		/// <summary>
		/// This tests the serialization
		/// </summary>
		[Test]
		public void SerializationTest()
		{

			Bookmarks bookmarks = new Bookmarks();
			bookmark1 = new Bookmark("Bookmark1", @"http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/front_page/rss.xml");
			bookmarks.AddBookmark(bookmark1);
			bookmark2 = new Bookmark("Bookmark2", @"http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/technology/rss.xml", 10);
			bookmarks.AddBookmark(bookmark2);

			bookmarks.Save("Bookmarks.xml");
			bookmarks = Bookmarks.Load("Bookmarks.xml");

			Logger.Log(bookmarks.ToString());
		}
		


	}
}
