/* -------------------------------------------------------------------------
 | Copyright (C) 2006  Ali Rawashdeh
 | This program is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 | 
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 | 
 | You should have received a copy of the GNU General Public License along
 | with this program (see License.txt); if not, write to the Free Software
 | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------*/
using System;
using HomeDev.Useful;
using HomeDev.RSSTicker.Objects;
using NUnit.Framework;
using System.Xml;
using System.Xml.Serialization;
using System.IO;


namespace UnitTests
{
	/// <summary>
	/// Unit test for the Feed class
	/// </summary>
	[TestFixture]
	public class Feed_UT
	{

		// Declarations
		Bookmark bookmark1;
		Feed feed1;

		public Feed_UT()
		{
		}
		
		// Setup method
		[SetUp]
		public void Setup()
		{
			Logger.Open("log.txt", true);
		}

		// Teardown method
		[TearDown]
		public void Teardown()
		{
			Logger.Close();
		}

		/// <summary>
		/// This tests the constructors and the bookmark object
		/// </summary>
		[Test]
		public void FeedTest()
		{
			bookmark1 = new Bookmark("Bookmark1", @"http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/front_page/rss.xml");
			feed1 = new Feed(bookmark1);
			feed1.UpdateFeed();

			Logger.Log(feed1.ToString());
		}
	}
}
